<?php

/*
=====================================================
 This ExpressionEngine plugin was created by Laisvunas
 - http://devot-ee.com/developers/ee/laisvunas/
=====================================================
 Copyright (c) Laisvunas
=====================================================
 You may use this code on any website you are developing.
 Unless you have been granted prior, written consent from Laisvunas, you may not:
 * Reproduce, distribute, or transfer the Software, or portions thereof, to any third party
 * Sell, rent, lease, assign, or sublet the Software or portions thereof
 * Grant rights to any other person
=====================================================
 File: pi.blog_info.php
-----------------------------------------------------
 Purpose: to output info about certain weblog. 
=====================================================
*/

$plugin_info = array(
						'pi_name'			=> 'Blog Info',
						'pi_version'		=> '1.1',
						'pi_author'			=> 'Laisvunas',
						'pi_author_url'		=> 'http://devot-ee.com/developers/ee/laisvunas/',
						'pi_description'	=> 'Allows you to output info about certain weblog.',
						'pi_usage'			=> blog_info::usage()
					);
					
class Blog_info {

  var $return_data="";
  
  function Blog_info()
  {
    global $TMPL, $DB, $FNS;
    
    // Fetch the tagdata
		  $tagdata = $TMPL->tagdata;
		  
		  // Fetch params
		  $site = $TMPL->fetch_param('site') ? $TMPL->fetch_param('site') : 1;
    $blog_id_num = $TMPL->fetch_param('blog_id');    
    $blog_name = $TMPL->fetch_param('blog_name');
    $invalid_input = $TMPL->fetch_param('invalid_input');    
		    
    // Define variables    
    $conds = array();
    $error_encountered = FALSE;
    $param_names = array();    
    $param_names2 = array();
    $values_max_number = 50;
    $blog_ids = array();    
    $blog_names = array();    
    $blog_clause = '';    
    $blog_clause2 = '';    
    $blog_info_rows2 = array();    
    $blog_info_rows3 = array();
    
    for ($i = 1; $i <= $values_max_number; $i++)
    {
      if ($TMPL->fetch_param('blog_id_'.$i) !== FALSE)      
      {
        $blog_ids[$i.''] = $TMPL->fetch_param('blog_id_'.$i);
        //echo '$blog_ids['.$i.'""]: '.$blog_ids[$i.''].'<br><br>'.PHP_EOL;       
      }      
      if ($TMPL->fetch_param('blog_name_'.$i) !== FALSE)      
      {
        $blog_names[$i.''] = $TMPL->fetch_param('blog_name_'.$i);        
      }
    }    

    // Either parameter "blog_id" or parameter "blog_name" must be defined    
    if ($blog_id_num === FALSE AND $blog_name === FALSE AND count($blog_ids) == 0 AND count($blog_names) == 0)    
    {
      $error_encountered = TRUE;
      if ($invalid_input === 'alert')
      {
        echo 'ERROR! At least one of the parameters "blog_id", "blog_id_1", "blog_id_2" etc., or atleast one of the parameters "blog_name", "blog_name_1", "blog_name_2" etc. of the exp:blog_info tag must be defined!<br><br>';
      } 
    }
        
    if ($error_encountered === FALSE)    
    {
      if ($blog_id_num !== FALSE)
      {
        $blog_clause = " AND weblog_id='".$blog_id_num."' ";
      }
      
      if ($blog_name !== FALSE)
      {
        $blog_clause = " AND blog_name='".$blog_name."' ";
      }    
  		      
      if ($blog_clause != '')      
      {
        $sql_blog_info = "SELECT *
                          FROM exp_weblogs
                          WHERE 
                            site_id='".$site."'"
                            .$blog_clause."
                          LIMIT 1";                      
        $query_blog_info = $DB->query($sql_blog_info);    
    
        if ($query_blog_info->num_rows == 1)    
        {
          $conds['blog_info_id'] = $query_blog_info->row['weblog_id'];
          $conds['blog_info_name'] = $query_blog_info->row['blog_name']; 
          $conds['blog_info_title'] = $query_blog_info->row['blog_title'];
          $conds['blog_info_url'] = $query_blog_info->row['blog_url'];
          $conds['blog_info_description'] = $query_blog_info->row['blog_description'];
          $conds['blog_info_lang'] = $query_blog_info->row['blog_lang'];
          $conds['blog_info_encoding'] = $query_blog_info->row['blog_encoding']; 
        }
      }
      
      if (count($blog_ids) > 0)    
      {
        //echo 'count($blog_ids): '.count($blog_ids).'<br><br>'.PHP_EOL;
        foreach ($blog_ids as $blog_id)        
        {
          $blog_clause .= " OR weblog_id='".$blog_id."' ";
        }        
        if (count($blog_ids) == 1)        
        {        
          $blog_clause = " AND ".substr($blog_clause, 4)." ";
        }        
        if (count($blog_ids) > 1)        
        {
          $blog_clause = " AND (".substr($blog_clause, 4).") ";
        }        
        $sql_blog_info2 = "SELECT *
                          FROM exp_weblogs
                          WHERE 
                            site_id='".$site."'"
                            .$blog_clause;                            
        $query_blog_info2 = $DB->query($sql_blog_info2);
      }
             
      if (count($blog_names) > 0)      
      {
        //echo 'count($blog_names): '.count($blog_names).'<br><br>'.PHP_EOL;
        foreach ($blog_names as $blog_name)        
        {
          $blog_clause2 .= " OR blog_name='".$blog_name."' ";
        }        
        if (count($blog_names) == 1)        
        {        
          $blog_clause2 = " AND ".substr($blog_clause2, 4)." ";
        }        
        if (count($blog_names) > 1)        
        {
          $blog_clause2 = " AND (".substr($blog_clause2, 4).") ";
        }        
        $sql_blog_info3 = "SELECT *
                          FROM exp_weblogs
                          WHERE 
                            site_id='".$site."'"
                            .$blog_clause2;                            
        $query_blog_info3 = $DB->query($sql_blog_info3);
      }
    }    

    if (isset($query_blog_info2) AND $query_blog_info2->num_rows > 0)    
    {
      foreach($query_blog_info2->result as $row)      
      {
        $blog_info_rows2[$row['weblog_id']] = $row;
      }      
      foreach ($blog_ids as $key => $blog_id)      
      {
        if (isset($blog_info_rows2[$blog_id]))        
        {
          $conds['blog_info_id_'.$key] = $blog_id;
          $conds['blog_info_name_'.$key] = $blog_info_rows2[$blog_id]['blog_name']; 
          $conds['blog_info_title_'.$key] = $blog_info_rows2[$blog_id]['blog_title'];
          $conds['blog_info_url_'.$key] = $blog_info_rows2[$blog_id]['blog_url'];
          $conds['blog_info_description_'.$key] = $blog_info_rows2[$blog_id]['blog_description'];
          $conds['blog_info_lang_'.$key] = $blog_info_rows2[$blog_id]['blog_lang'];
          $conds['blog_info_encoding_'.$key] = $blog_info_rows2[$blog_id]['blog_encoding'];
        }
      }
    }    

    if (isset($query_blog_info3) AND $query_blog_info3->num_rows > 0)    
    {
      foreach($query_blog_info3->result as $row)      
      {
        $blog_info_rows3[$row['blog_name']] = $row;
      }      
      foreach ($blog_names as $key => $blog_name)      
      {
        if (isset($blog_info_rows3[$blog_name]))        
        {
          $conds['blog_info_id_'.$key] = $blog_info_rows3[$blog_name]['weblog_id'];
          $conds['blog_info_name_'.$key] = $blog_name; 
          $conds['blog_info_title_'.$key] = $blog_info_rows3[$blog_name]['blog_title'];
          $conds['blog_info_url_'.$key] = $blog_info_rows3[$blog_name]['blog_url'];
          $conds['blog_info_description_'.$key] = $blog_info_rows3[$blog_name]['blog_description'];
          $conds['blog_info_lang_'.$key] = $blog_info_rows3[$blog_name]['blog_lang'];
          $conds['blog_info_encoding_'.$key] = $blog_info_rows3[$blog_name]['blog_encoding'];
        }
      }
    }
       
    if ($error_encountered === TRUE OR (isset($query_blog_info) AND $query_blog_info->num_rows != 1) OR (isset($query_blog_info2) AND $query_blog_info2->num_rows == 0) OR (isset($query_blog_info3) AND $query_blog_info3->num_rows == 0))    
    {
      $conds['blog_info_id'] = '';
      $conds['blog_info_name'] = ''; 
      $conds['blog_info_title'] = '';
      $conds['blog_info_url'] = '';
      $conds['blog_info_description'] = '';
      $conds['blog_info_lang'] = '';
      $conds['blog_info_encoding'] = '';      
            
      foreach ($blog_ids as $key => $blog_id)      
      {
        $conds['blog_info_id_'.$key] = '';
        $conds['blog_info_name_'.$key] = ''; 
        $conds['blog_info_title_'.$key] = '';
        $conds['blog_info_url_'.$key] = '';
        $conds['blog_info_description_'.$key] = '';
        $conds['blog_info_lang_'.$key] = '';
        $conds['blog_info_encoding_'.$key] = '';
      }      

      foreach ($blog_names as $key => $blog_name)      
      {
        $conds['blog_info_id_'.$key] = '';
        $conds['blog_info_name_'.$key] = ''; 
        $conds['blog_info_title_'.$key] = '';
        $conds['blog_info_url_'.$key] = '';
        $conds['blog_info_description_'.$key] = '';
        $conds['blog_info_lang_'.$key] = '';
        $conds['blog_info_encoding_'.$key] = '';
      }
    }
        
    $tagdata = $FNS->prep_conditionals($tagdata, $conds);    
    foreach ($conds as $key => $value)    
    {
      $tagdata = $TMPL->swap_var_single($key, $value, $tagdata);
    }
    // Replace variables which did not output anything    
    $tagdata = preg_replace('/\{?(blog_info_id_)[0-9]+\}?/i', '', $tagdata);    
    $tagdata = preg_replace('/\{?(blog_info_name_)[0-9]+\}?/i', '', $tagdata);    
    $tagdata = preg_replace('/\{?(blog_info_title_)[0-9]+\}?/i', '', $tagdata);
    $tagdata = preg_replace('/\{?(blog_info_url_)[0-9]+\}?/i', '', $tagdata);
    $tagdata = preg_replace('/\{?(blog_info_description_)[0-9]+\}?/i', '', $tagdata);
    $tagdata = preg_replace('/\{?(blog_info_lang_)[0-9]+\}?/i', '', $tagdata);    
    $tagdata = preg_replace('/\{?(blog_info_encoding_)[0-9]+\}?/i', '', $tagdata);

    return $this->return_data = $tagdata;
  }
  // END FUNCTION
  
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------
// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>

PARAMETERS:

1) blog_id - Optional. Allows you to specify weblog ID number. You also can specify 
up to 50 weblog ID numbers using parameters blog_id_1, blog_id_2, blog_id_3 ...
blog_id_48, blog_id_49, blog_id_50. 

2) blog_name - Optional. Allows you to specify short name of the weblog. You also can specify 
up to 50 weblog short name using parameters blog_name_1, blog_name_2, blog_name_3 ...
blog_name_48, blog_name_49, blog_name_50.

Either parameter "blog_id" or parameter "blog_name" must be defined

3) site - Optional. Allows you to specify site id number. Default value is "1".

4) invalid_input - Optional. Accepts two values: “alert” and “silence”.
Default value is “silence”. If the value is “alert”, then in cases when 
the plugin has some problem with parameters,  PHP alert is being shown;
if the value is “silence”, then in cases when the plugin has 
some problem with parameters, it finishes its work without any alert being shown. 
Set this parameter to “alert” for development, and to “silence” - for deployment. 

VARIABLES:

1) blog_info_id - weblog ID number.

2) blog_info_name - short name of the weblog.

3) blog_info_title - displays the content from the "Full Weblog Name" setting.

4) blog_info_url - displays the content from the "Weblog URL" setting.

5) blog_info_description - displays the content from the "Weblog Description" field in CP.

6) blog_info_lang - displays the content from the "XML Language" setting.

7) blog_info_encoding - displays the content from the "XML Character Encoding" setting.

Conditionals are supported.

EXAMPLE OF USAGE:

{exp:blog_info blog_name="my_blog" site="1"}
Weblog id: {blog_info_id}<br>
Weblog short name: {blog_info_name}<br>
Weblog title: {blog_info_title}<br>
Weblog URL: {blog_info_url}<br>
Weblog description: {blog_info_description}<br>
weblog language: {blog_info_lang}<br>
Weblog encoding: {blog_info_encoding}<br>
{/exp:blog_info}
<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
// END USAGE

}
// END CLASS
?>